module;
#include <format>
#include <iostream>
#include <string>

export module Window;

// Definition der allg. Fensterklasse
export class Window
{
    short xPos, yPos;       // Fensterposition
    short width, height;    // Fenstergrösse
    std::string title;      // Fenstertitel
public:
    // ctor
    Window(short x, short y, short w, short h,
           const char* const pT);
    // Zuweisung von Fenster-Objekten unterbinden
    Window& operator = (const Window&) = delete;
    // Memberfunktionen zum Verschieben und Zeichnen des Fensters
    void MoveWindow(short x, short y);
    void Draw() const;
};
// Defintion der Memberfunktionen
// Konstruktor
Window::Window(short x, short y, short w, short h,
               const char* const pT):
               xPos(x), yPos(y), width(w),
               height(h), title(pT)
{}
// Verschiebt Fenster
inline void Window::MoveWindow(short x, short y)
{
    xPos = x; yPos = y;
}
// Zeichnet Fenster
void Window::Draw() const
{
    std::cout << std::format("Fenster: {}\nPosition: ({},{}), Groesse: ({},{})\n",
        title, xPos, yPos, width, height);
}

