module;
#include <iostream>
#include <string>

export module FrameWin;
export import Window;

// Abgeleitete Klasse für Rahmenfenster
export class FrameWin: public Window
{
public:
    // enums für Rahmenfarbe, müssen public sein da
    // sie im ctor benötigt werden
    enum class FColor{ROT=0xFF0000,GRUEN=0x00FF00,BLAU=0x0000FF};
private:
    FColor frameColor;     // Rahmenfarbe
public:
    // ctor
    FrameWin(short x, short y,
             const char* const pT, FColor eFC);
    // Memberfunktion zum Zeichnen des Fensters
    void Draw() const;
};
// Definition der Memberfunktionen
// Konstruktor
FrameWin::FrameWin(short x, short y,
                   const char* const pT, FColor eFC)
    :Window(x, y, 640, 480, pT), frameColor(eFC)
{}
// Zeichnet Fenster
void FrameWin::Draw() const
{
    // 'Normales' Fenster zeichnen
    Window::Draw();
    // Rahmenfarbe darstellen
    std::cout << "Rahmenfarbe: ";
    switch (frameColor)
    {
        using enum FColor;
    case ROT:
        std::cout << "rot\n\n";
        break;
    case BLAU:
        std::cout << "blau\n\n";
        break;
    case GRUEN:
        std::cout << "grün\n\n";
    }
}
