/********************** Fuer GCC *******************************
*  Solange GCC kein std::string in Modulen verarbeiten kann sind
*  anstelle der Anweisung
*       import Monitor
*  folgende Datei(en) einzufuegen:
*       abgel_02a.cxx und abgel_02b.cxx
*
*****************************************************************/

#include <iostream>
#include <fstream>
#include <string>

import Monitor;

constexpr int SIZE = 3;

// main() Funktion
int main()
{
    // Feld fuer Zeiger auf Monitor-Objekte
-    Monitor *pLager[SIZE];

    // Einlesen der Monitordaten
    for (auto index = 0; index < SIZE; index++)
    {
        std::string inName;         // Monitorname
        unsigned short inDiag;      // Diagonale
        // Daten einlesen
        std::cout << "Monitorbezeichnung? ";
        std::getline(std::cin, inName);
        std::cout << "Diagonale? ";
        std::cin >> inDiag;
        // Monitor-Objekt erstellen
        pLager[index] = new Monitor{ inName.c_str(), inDiag };
        // <RETURN> aus Eingabepuffer entfernen!
        std::cin.ignore();
    }

    // Daten ausgeben
    for (auto index = 0; index < SIZE; index++)
        std::cout << *pLager[index];

    // Daten in Datei ablegen
    std::ofstream outFile("c:/temp/monitor.dat");
    if (outFile)
    {
        for (auto index = 0; index < SIZE; index++)
            outFile << *pLager[index];
        outFile.close();
    }
    // Nicht vergessen: Speicher freigeben!!
    for (auto index = 0; index < SIZE; index++)
        delete pLager[index];

}
