module;
#include <iostream>
#include <fstream>
#include <format>

export module Monitor;
export import Artikel;

// Von Artikel abgeleitete Klasse Monitor
export class Monitor: public Artikel
{
    unsigned short diagonale;       // Diagonale
public:
    Monitor() = default;
    Monitor(const char* const name, unsigned short diag) : Artikel(name)
    {
        diagonale = diag;
    }
    friend std::ostream& operator << (std::ostream& os, const Monitor& mon);
    friend std::ofstream& operator << (std::ofstream& of, const Monitor& mon);
};

export std::ostream& operator << (std::ostream& os, const Monitor& mon)
{
    os << std::format("Art-Nr.: {}, Monitor: {}, Diagonale: {}\n", mon.nummer, mon.name, mon.diagonale);
    return os;
}
export std::ofstream& operator << (std::ofstream& of, const Monitor& mon)
{
    of << std::format("{};{};{}\n", mon.nummer, mon.name, mon.diagonale);
    return of;
}
