/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import Demo
*  folgende Datei(en) einzufuegen:
*       demo.cxx
*
*****************************************************************/

#include <iostream>
#include <format>
#include <array>
#include <stdexcept>
#include <algorithm>
#include <ranges>

import Demo;

// Demo-array anlegen und initialisieren
std::array<Demo,4> demoObj {"eins","zwei","drei","vier"};
// Lambda-Funktion zur Ausgabe eines Demo-Objekts
auto PData = [](const Demo& obj) {std::cout << std::format("{},",obj); };

int main()
{
    // array ausgeben
    std::ranges::for_each(demoObj, PData);
    std::cout << '\n';
    // array rueckwaerts ausgeben
    std::ranges::for_each(std::views::reverse(demoObj), PData);
    std::cout << '\n';
    // Zugriff auf array Elemente
    // 2. Zugriff schlaegt fehl und loest Ausnahme aus
    try
    {
        std::cout << std::format("1. Element: {}\n", demoObj.at(0));
        demoObj.at(9) = "neun";
    }
    catch (std::out_of_range& ex)
    {
        std::cout << "Fehler: " << ex.what() << '\n';
    }
    // array mit neuen Daten fuellen
    // und ausgeben
    demoObj.fill("alles neu");
    std::ranges::for_each(demoObj, PData);
    std::cout << '\n';
}
