// Dateien einbinden
#include <iostream>
#include <exception>

import Stack;

// main() Funktion
int main()
{
    // Zeiger auf short-Stack
    Stack *pStack;
    // Versuche short-Stack mit 5 Elementen anzulegen
    try
    {
        pStack = new Stack(5);
    }
    // Falls Fehler beim Anlegen des Stack aufgetreten
    // Meldung ausgeben und Programm beenden
    catch(const std::length_error& ex)
    {
        std::cout << ex.what();
        exit(1);
    }
    // Stack nun komplett füllen
    // Falls Stack voll ist wird Ausnahme ausgelöst
    std::cout << "Fuelle Stack:\n";
    try
    {
        short index = 10;
        for (;;)
            pStack->Push(index++);
    }
    catch(const std::out_of_range& ex)
    {
        std::cout << ex.what();
    }
    // Stack jetzt wieder leeren
    // Falls Stack leer wird Ausnahme ausgelöst
    std::cout << "Leere Stack:\n";
    try
    {
        for (;;)
            std::cout << pStack->Pop() << ',';
    }
    catch(const std::out_of_range& ex)
    {
        std::cout << ex.what();
    }
    // Stack löschen
    delete pStack;

    // Versuche zu grossen Stack anzulegen
    std::cout << "Lege riesigen Stack an:\n";
    try
    {
        Stack hugeStack(1000);
    }
    catch(const std::length_error& ex)
    {
        std::cout << ex.what();
        exit(1);
    }
}
