#include <iostream>
#include <format>
#include <algorithm>
#include <vector>
#include <string>
#include <string_view>

using namespace std::string_literals;

int main()
{
    // Vektor mit Abflugdaten
    // Uhrzeit, Ort, Flugnummer
    struct fdata
    {
        std::string time;
        std::string destination;
        std::string flightnr;
    };
    std::vector<fdata> fluege
    {
        {"10:20"s, "Hamburg"s, "EW2046"s},
        {"10:40"s, "Atlanta"s, "DL117"s},
        {"10:45"s, "Frankfurt"s, "LH133"s},
        {"10:45"s, "Rom"s, "EW2884"s},
        {"10:50"s, "Kavala"s, "EW2688"s},
        {"11:00"s, "Istanbul"s, "TK1702"s}
    };

    // Anzahl der Eurowings Fluege (EW...)
    // Projektion auf flightnr
    auto anzEW = std::ranges::count_if(fluege,
                               [] (std::string_view val) -> bool
                               {
                                   return val.find("EW") != std::string::npos;
                               },
                               &fdata::flightnr
                               );
    std::cout << std::format("{} Eurowing Fluege gefunden.\n", anzEW);

    // Gibt es auch Fluege vor 10:00 Uhr
    // Projektion nun auf time
    auto vor10 = std::ranges::any_of(fluege,
                             [] (std::string_view val) -> bool
                             {
                                 return val < "09:59"s;
                             },
                            &fdata::time
                             );
    if (vor10)
        std::cout << "Einige Fluege vor 10:00 Uhr\n";
    else
        std::cout << "Keine Fluege vor 10:00 Uhr\n";
}
