module;
#include <iostream>
#include <format>
#include <string>
#include <string_view>

export module Win;

// Klassendefinition
export class Window
{
   // enum mit Fensterstilen
   // enums sind hier Bitwerte da Fensterstile verodert werden können!
 public:
   enum eWINSTYLE {SYSMENU=0x01, MINBOX=0x02, MAXBOX=0x04, CLOSEBOX=0x08};
   // Eigenschaften
 private:
   int width, height;
   int xPos, yPos;
   std::string title;
   enum eWINSTYLE style;
   // Memberfunktionen
 public:
   Window (const int x, const int y, const int w, const int h,
           std::string_view t, const eWINSTYLE s);
   ~Window();
   void Paint() const;
   void MoveWin(const int x, const int y);
   void ResizeWin(const int, const int);
};
// Konstruktor
// ACHTUNG! Das string Objekt für den Fenstertitel sollte
// über die Initialisiererliste initialisiert werden damit
// es bei seiner Definition auch gleich initialisert wird!
Window::Window(const int x, const int y, const int w, const int h,
               std::string_view t, const eWINSTYLE s): title(t)
{
   xPos = x; yPos = y; // Fensterposition
   width = w; height = h; // Fenstergrösse
   style = s; // Fensterstil
   std::cout << std::format("{} erstellt\n", title);

}
// Destruktor
Window::~Window()
{
    // Nur Meldung ausgeben
    std::cout << std::format("{} geloescht\n", title);
}
// Fenster 'darstellen'
void Window::Paint() const
{
    std::cout << std::format(
        "{}\n\tPosition:{},{}\tGroesse:{},{}\n\tStil:{}\n\n",
        title,xPos, yPos, width, height,static_cast<int>(style));
}
// Fenster verschieben
inline void Window::MoveWin(const int x, const int y)
{
   xPos = x; yPos = y;
}
// Fenstergrösse verändern
void Window::ResizeWin(const int w, const int h)
{
   width = w; height = h;
}
