#include <iostream>
#include <format>
#include <deque>
#include <string>
#include <algorithm>

int main()
{
    // Deque mit den Arbeitsauftraegen
    std::deque<std::string> workPackages;
    // Lambda-Funktion zur Ausgabe eines Arbeitsauftrags
    auto PData = [](std::string_view view)
    { std::cout << std::format("{}\n", view); };

    // Drei Arbeitsauftraege ablegen
    workPackages.emplace_front("Arbeitsaufrag 1");
    workPackages.emplace_front("Arbeitsaufrag 2");
    workPackages.emplace_front("Arbeitsaufrag 3");

    // Alle Arbeitsauftraege ausgeben
    std::cout << "Anstehende Arbeiten:\n";
    std::ranges::for_each(workPackages, PData);

    // Zwei Arbeitsauftraege bearbeiten
    std::cout << "Bearbeite 2 Arbeitsauftaege:\n";
    PData(workPackages.back());
    workPackages.pop_back();
    PData(workPackages.back());
    workPackages.pop_back();

    // Alle Arbeitsauftraege ausgeben
    std::cout << "Noch offene Arbeitsauftaege:\n";
    std::ranges::for_each(workPackages, PData);

    // Neuen Arbeitsauftrag hinzufuegen
    std::cout << "Neuer Arbeitsaufrag:\n";
    workPackages.emplace_front("Arbeitsaufrag 4");

    // Alle Arbeitsauftraege ausgeben
    std::cout << "Noch offene Arbeitsauftaege:\n";
    std::ranges::for_each(workPackages, PData);

    // Alle Arbeitsauftraege abarbeiten
    std::cout << "Alle Arbeitsauftaege abarbeiten:\n";
    while (!workPackages.empty())
    {
        PData(workPackages.back());
        workPackages.pop_back();
    }
}
