module;
#include <iostream>
#include <format>
#include <cstdlib>

export module Measure;

// Datentyp der Messwerte
using DTYPE = unsigned short;

export class Measurement
{
    DTYPE   *values;            // Zeiger auf Messwerte
    int     noOfValues;         // Anzahl der Messwerte
public:
    // ctor, reserviert Feld fuer Messwert
    explicit  Measurement(int size): noOfValues(size)
    {
        values = new DTYPE[size];
    }
    // dtor, gibt Feld fuer Messwert wieder frei
    ~Measurement()
    {
        delete [] values;
    }
    // Messwerte erzeugen
    void Start()
    {
        for (auto index=0; index<noOfValues; index++)
            values[index] = std::rand() % 100;
    }
    // Messwerte sowie Mittelwert ausgeben
    void PrintValues()
    {
        unsigned long sum = 0;

        std::cout << "Werte: ";
        for (auto index=0; index<noOfValues; index++)
        {
            std::cout << std::format("{},", values[index]);
            sum += values[index];
        }
        std::cout << std::format("\nMittelwert: {}\n", sum / noOfValues);
    }
};
