/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import Window
*  folgende Datei(en) einzufuegen:
*       dynprop_04a.cxx
*
*****************************************************************/
#include <iostream>
#include <format>
#include <fstream>

import Window;

// Konstanten
const char* FILENAME = "../../04_Data/fenster01.txt"; // Datei mit Fensterdaten

// main() Funktion
int main()
{
    std::ifstream winFile; // Datei mit den Fensterdaten
    int noOfWin; // Anzahl der Fensterdaten i.d. Datei

    // Datei mit Fensterdaten öffnen
    winFile.open(FILENAME);
    if (!winFile)
    {
        std::cout << std::format("Fehler beim Oeffnen der Datei {}\n", FILENAME);
        exit(1);
    }

    // Anzahl der Fensterdaten einlesen
    winFile >> noOfWin;

    // Feld für die Fensterdaten anlegen
    auto pWindow = new Window[noOfWin];

    // Nun alle Fensterdaten aus Datei einlesen
    for (auto index=0; index<noOfWin; index++)
    {
         // Fehler abfangen!
        if (auto success = pWindow[index].ReadFromFile(winFile); !success)
        {
            std::cout << std::format("Fehler beim Einlesen des {}. Fensters!\n", index + 1);
            // Anzahl der Fenster korrigieren und Schleife verlassen
            noOfWin = index;
            break;
        }
    }

    // Datei nun wieder schliessen
    winFile.close();

    // Alle Fensterdaten ausgeben
    for (auto index=0; index<noOfWin; index++)
        pWindow[index].Print();

    // Feld mit Fensterdaten löschen
    // Unbedingt die eckigen Klammern beachten!!
    delete [] pWindow;
}
