#include <iostream>
#include <fstream>
#include <format>

// Dateiname
constexpr auto pszDATEI = "../../04_Data/dax.txt";

// main() Funktion
int main()
{
	// Datei oeffnen
	std::fstream inFile(pszDATEI, std::ios::in|std::ios::out|std::ios::app);
	if (!inFile)
	{
		std::cout << std::format("Kann Datei {} nicht oeffnen!\n", pszDATEI);
		exit(1);
	}
	// Einzulesender Kurs
	float kurs;
	// Einlesen bis Dateiende erreicht
	std::cout << "Kurswerte gestern:\n";
	do
	{
		// Kurs einlesen
		inFile >> kurs;
		// Wenn nicht Dateieinde erreicht, Kurs ausgeben
		if (!inFile.eof())
			std::cout << std::format("Eingelesener Kurs: {:.2f}\n", kurs);
	} while (!inFile.eof());

	// Neuer Kurswert = letzter Kurswert plus 1.2%
	kurs *= 1.012f;
	// eof-Status zuruecksetzen
	inFile.clear();
	// Neuen Kurs mit in Datei aufnehmen
	inFile << std::format("{:.2f}\n", kurs);

	// Lesezeiger zuruecksetzen auf Dateianfang
	inFile.seekg(0, std::ios::beg);
	// Alle Kurswerte wieder einlesen
	std::cout << "\nKurswerte heute:\n";
	// Einlesen bis Dateiende erreicht
	do
	{
		// Kurs einlesen
		inFile >> kurs;
		// Wenn nicht Dateieinde erreicht, Kurs ausgeben
		if (!inFile.eof())
			std::cout << std::format("Eingelesener Kurs: {:.2f}\n", kurs);
	} while (!inFile.eof());

	// Datei schliessen
	inFile.close();
}
