#include <iostream>
#include <fstream>
#include <format>

// Dateiname
constexpr auto pszDATEI = "../../04_Data/messw.dat";

// main() Funktion
int main()
{
	// Datei oeffnen
	std::ifstream inFile(pszDATEI, std::ios::binary | std::ios::in);
	// Fehler abfangen
	if (!inFile)
	{
		std::cout << std::format("Fehler beim Oeffnen der Datei {}\n", pszDATEI);
		exit(1);
	}

	// Kleinster/groesster Messwert
	unsigned short min = 9999, max = 0;
	// Alle Daten aus Datei einlesen
	do
	{
		// Wert aus Datei einlesen
		unsigned int wert;
		inFile.read(reinterpret_cast<char*>(&wert), sizeof wert);
		// Wenn Dateiende erreicht, Sprung zum Schleifenende
		if (inFile.eof())
			continue;
		// Eingelesenen Wert ausgeben
		std::cout << std::format("Eingelesen: {}\n", wert);
		// Kleinsten/groessten Wert merken
		if (wert < min)
			min = wert;
		else
			if (wert > max)
				max = wert;

	} while (!inFile.eof());
	// Datei wieder schliessen
	inFile.close();

	// Kleinsten/groessten Wert ausgeben
	std::cout << std::format("Kleinster Wert: {}, groesster Wert: {}\n", min, max);
}
