#include <iostream>
#include <format>
#include <cmath>

// main() Funktion
int main()
{
    // Konstanten definieren
    constexpr auto GRAVITATION = 9.81;
    constexpr auto GRAD2RAD = 2.0 * 3.1416 / 360.0;

    // Abwurfgeschwindigkeit
    auto geschw = 10.0;

    // Abwurfwinkel im Bereich 10...85 Grad durchlaufen
    for (auto winkel = 10.0; winkel < 90.0; winkel += 5.0)
    {
        // Winkel von Grad in Radiant umrechnen
        auto wrad = winkel * GRAD2RAD;
        // Wurfweite berechnen
        auto weite = (geschw * geschw * sin(2.0 * wrad)) / GRAVITATION;
        // Wurfhöhe berechnen
        auto hoehe = (geschw * geschw) * (sin(wrad) * sin(wrad)) / (2.0 * GRAVITATION);
        // Ergebnis ausgeben
        std::cout << std::format("Winkel: {:2} Grad -> Weite: {:5.2f}m, Hoehe: {:5.2f}m\n",
            winkel, weite, hoehe);
    }
}
