module;
#include <iostream>
#include <format>
#include <string>

export module Address;

// Definition der Klasse für die Adressdaten
export class Address
{
    std::string name; // Name
    std::string location; // Ort
public:
    Address() = default; // ctor, hat nichts zu tun
    // copy-ctor
    Address(const Address& obj2) = default;
    // Move-Konstruktor
    Address(Address&& obj2);
    // Move-Operator =
    Address& operator = (Address&& obj);
    // Überladener Zuweisungsoperator
    Address& operator = (const Address& obj2);
    // Adressdaten setzen
    void SetData(const char* const pN, const char* const pL);
    // Überladener << Operator für Ausgabe
    friend std::ostream& operator << (std::ostream& os, const Address& obj2);
    // Überladener > Operator für Vergleich
    bool operator > (const Address& obj2) const;
};
// Definition der Memberfunktionen
// Move-Konstruktor
Address::Address(Address&& obj2)
{
    // Eigenschaften transferieren
    name = std::move(obj2.name);
    location = std::move(obj2.location);
    // Quell-Objekt in gueltigen Zustand versetzen
    obj2.name.clear();
    obj2.location.clear();
}
// Move-Operator =
Address& Address::operator = (Address&& obj2)
{
    // Eigenschaften transferieren
    name = std::move(obj2.name);
    location = std::move(obj2.location);
    // Quell-Objekt in gueltigen Zustand versetzen
    obj2.name.clear();
    obj2.location.clear();
    return *this;
}
// setzen der Adressdaten
void Address::SetData(const char* const pN, const char* const pL)
{
    name = pN;
    location = pL;
}
// Vergleichoperator überladen für Vergleich
// innerhalb der Templatefunktion Sort(...)
inline bool Address::operator > (const Address& obj2) const
{
    return (name > obj2.name);
}
// Zuweisungsoperator überladen für Zuweisungen
// innerhalb der Templatefunktion Swap(...)
Address& Address::operator = (const Address& obj2)
{
    if (&obj2 == this)
        return *this;
    name = obj2.name;
    location = obj2.location;
    return *this;
}

// Überladener Operator << für Ausgabe
export std::ostream& operator << (std::ostream& os, const Address& addr)
{
    os << std::format("Name: {}, Ort: {}\n", addr.name, addr.location);
    return os;
}
