/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import MyArray
*  folgende Datei(en) einzufuegen:
*       htemp_01a.cxx
*
*****************************************************************/

#include <iostream>
#include <format>
#include <string>
#include <tuple>

using std::string;
using namespace std::string_literals;

import MyArray;

// Alias fuer tuple
// departure dient zum Abspeichern der Daten eines Fluges
// Stunde, Minute, Flugnummer und Zielort
using departure = std::tuple<short,short,string,string>;
// Feldgroesse
constexpr auto MAXDATA =4;

// main() Funktion
int main()
{
    // Tuple-Feld definieren
    MyArray<departure,MAXDATA> timeTable;

    try
    {
        // Flugdaten ablegen
        timeTable.AddData({ 11, 30, "X3 2345"s, "Palma de Mallorca"s });
        timeTable.AddData({ 11, 45, "LH 3453"s, "New York"s });
        timeTable.AddData({ 11, 50, "DE 264"s, "Teneriffe South"s });
        timeTable.AddData({ 12, 05, "4U 9876"s, "Berlin"s});

        // Daten wieder auslesen
        for (auto index = 0; index < MAXDATA; index++)
        {
            auto [hour, minute, fnumber, destination] = timeTable.GetData(index);
            std::cout << std::format("{:02}:{:02}\tFlug: {},\tZiel: {}\n",
                hour, minute, fnumber, destination);
        }
    }
    catch (const std::exception& ex)
    {
        std::cout << ex.what() << '\n';
    }
}
