module;
#include <tuple>
#include <stdexcept>

export module MyArray;

export template <typename T, int SIZE>
class MyArray
{
    T tArray[SIZE];     // Datenfeld
    int actSize = SIZE; // Groesse des Datenfelds
    int actIndex = 0;   // Aktueller Datenindex
public:
    // ctor
    MyArray ()
    {
    }
    // Kopieren und zuweisen verhindern
    MyArray(MyArray&) = delete;
    MyArray(MyArray&&) = delete;
    MyArray& operator = (const MyArray&) = delete;
    MyArray& operator = (const MyArray&&) = delete;
    // Daten setzen
    void AddData (const T& data)
    {
        if (actIndex == SIZE)
            throw std::out_of_range("Index ausserhalb erlaubten Bereich");
        tArray[actIndex++] = data;
    }
    // Daten auslesen
    const T& GetData (int index) const
    {
        if ((index<0) || (index>=actIndex))
            throw std::out_of_range("Index ausserhalb erlaubten Bereich");
        return tArray[index];
    }
};
