#include <iostream>
#include <format>
#include <string>

using namespace std::string_literals;

// Aktienkurse festlegen
std::pair<float, std::string> aktien[] {
    {47.60f,"Daimler"s},
    {141.88f,"VW"s},
    {62.30,"BMW"s},
    {31.18f,"General Motors"s}};
// Anzahl der Kurse
constexpr auto SSIZE = sizeof(aktien)/sizeof(aktien[0]);

// main() Funktion
int main()
{
    size_t index;

    // Aktienkurs ausgeben
    std::cout << "Aktienkurse:\n-----------:\n";
    for (auto [kurs, hersteller]: aktien)
    {
        std::cout << std::format("Hersteller: {}, Kurs: {:.2F}\n",
            hersteller, kurs);
    }

    // VW Aktie um 111.11 erhöhen
    aktien[1].first += 5.0f;
    std::cout << "** VW Aktie um 5.00 erhoeht! **\n";

    // Aktien nach Wert sortieren
    bool changed;
    do
    {
        changed = false;
        for (index=0; index<SSIZE-1; index++)
        {
            // Vergleicht primär Kurse, sekundär Hersteller
            if (aktien[index]>aktien[index+1])
            {
                auto temp = aktien[index];
                aktien[index] = aktien[index+1];
                aktien[index+1] = temp;
                changed = true;
            }
        }
    } while (changed);

    // Sortierte Kurse nach Wert ausgeben
    std::cout << "\nKurse nach Wert sortiert:\n"
                   "-------------------------\n";
    for (auto [kurs, hersteller] : aktien)
    {
        std::cout << std::format("Hersteller: {}, Kurs: {:.2F}\n",
            hersteller, kurs);
    }
}
