module;
#include <iostream>
#include <format>

export module Histogram;

// Aktuelle Anzahl der Bereiche
//constexpr auto ANZKLASSEN = 10;

// Klassendefinition
export class Histogramm
{
   // Eigenschaften
   unsigned short werteZaehler[10]; // Zähler für Wertebereiche
   unsigned short intervall;                // Intervall eines Wertebereichs
   unsigned short maxv;                      // Zu klassifierender Max-Wert
 public:
   // Schnittstellen
   void Init(unsigned short maxVal); // Initialisierung
   void AddValue(unsigned short val); // Wert hinzufügen
   void PrintHistogramm() const; // Histogramm ausgeben
};

// Defínition der Memberfunktionen
// Eigenschaften initialisieren
// maxValue ist der max. Wert der zu klassifizierenden Daten
void Histogramm::Init(unsigned short maxVal)
{
   intervall = (maxVal+1) / 10; // Intervall pro Wertebereich
   maxv = maxVal;
}
// Wert hinzufügen
void Histogramm::AddValue(unsigned short val)
{
   // Abfrage ob Wert innerhalb des erlaubten Bereichs
   if (val>maxv)
      val = maxv;
   // Index des entspr. Zählers berechnen (Klasse)
   unsigned short klasse = val / intervall;
   // Zähler erhöhen
   werteZaehler[klasse]++;
}
// Anzahl der Werte pro Klasse ausgeben
void Histogramm::PrintHistogramm() const
{
   std::cout << "Verteilung:\n";
   for (auto index = 0; index < 10; index++)
       std::cout << std::format("{}...{}: {}\n",
           index * intervall, (index + 1) * intervall - 1, werteZaehler[index]);
}
