#include <iostream>
#include <format>
#include <fstream>
#include <string>

// Dateiname
const std::string FILENAME = "../../04_Data/names.txt";

// main() Funktion
int main()
{
   // Zeiger auf ein string Feld
   std::string *pStringArray;
   // Anzahl der Einträge in der Datei
   int noOfEntries;

   // Blockbeginn!
   // Da das ifstream Objekt innerhalb des Blocks definiert wird,
   // wird es beim Verlassen des Blocks automatisch gelöscht, was
   // wiederum zum Schliessen der Datei führt
   {
      // Datei öffnen
      std::ifstream inFile(FILENAME);
      if (!inFile)
      {
         std::cout << std::format("Datei {} konnte nicht geoeffnet werden!\n", FILENAME);
         exit(1);
      }

      // Anzahl der Einträge einlesen
      inFile >> noOfEntries;
      // Zeilenende CR/LF überspringen!
      inFile.ignore(1);
      // string Feld anlegen
      pStringArray = new std::string[noOfEntries];
      // Alle Namen einlesen
      for (auto index=0; index<noOfEntries; index++)
      {
         // Eine Zeile einlesen
         std::getline(inFile,pStringArray[index]);
      }
   } // Hier wird die Datei wieder geschlossen

   // Alle eingelesenen Zeilen jetzt ausgeben
   for (auto index = 0; index < noOfEntries; index++)
       std::cout << std::format("{:2}. Name: {}\n", index+1, pStringArray[index]);

   // string Feld freigeben
   delete [] pStringArray;
}
