module;
#include <iostream>
#include <format>

export module Rect;

// Klassendefinition
export class Rect
{
    short xPos = 0, yPos = 0;        // Position
    short width = 640, height = 480; // Breite und Höhe
  public:
    Rect() = default; // ctors
    Rect(short x, short y, short w, short h);
    void PrintRect()const; // Ausgabe des Rechtecks
    Rect operator & (const Rect& op2) const;            // Verundet zwei Rechtecke
    auto operator <=>(const Rect& op2) const = default; // Vergleicht zwei Rechtecke
    bool operator !() const;                            // Prüft auf leeres Rechteck ab
};
// Definition der Memberfunktionen
// 2. Konstruktor
// Erhält als Parameter die Rechteck-Daten als 4 short Werte
Rect::Rect(short x, short y, short w, short h)
{
    xPos = x; yPos = y;
    width = w; height = h;
}
// Ausgabe der Rechteck Daten
void Rect::PrintRect() const
{
    std::cout << std::format("Rechteck auf ({},{}), Groesse: ({},{})\n",
        xPos, yPos, width, height);
}
// Verundet zwei Rechtecke
// Das daraus resultierende Rechtecke enthält die Fläche,
// die beiden Rechtecken gemeinsam ist
Rect Rect::operator & (const Rect& op2) const
{
    // Resultierendes Rechteck
    Rect result;
    // Hilfsvariablen
    short end1, end2;
    // Grösste X-Position ist resultierende X-Position
    result.xPos = (op2.xPos>xPos) ? op2.xPos : xPos;
    // X-Positionen der rechten Kante berechnen
    end1 = xPos+width;
    end2 = op2.xPos+op2.width;
    // Kleinste X-Position bestimmte Breite des result. Rechtecks
    result.width = (end1>end2) ? end2-result.xPos : end1-result.xPos;
    // Nun das gleiche Spiel mit der Y-Position und der Höhe
    result.yPos = (op2.yPos>yPos) ? op2.yPos : yPos;
    end1 = yPos+height;
    end2 = op2.yPos+op2.height;
    result.height = (end1>end2) ? end2-result.yPos : end1-result.yPos;
    // Falls keine gemeinsame Fläche vorhanden ist
    // leeres Rechteck setzen
    if ((result.width <= 0) || (result.height <= 0))
    {
        result.width = result.height = 0;
        result.xPos = result.yPos = 0;
    }
    return result;
}
// Prüft ab, ob das Rechteck eine Fläche besitzt
bool Rect::operator ! () const
{
    if ((width == 0) || (height == 0))
        return true;
    else
        return false;
}
