/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import Graphics
*  folgende Datei(en) einzufuegen:
*       rtti_01a.cxx
*
*****************************************************************/

#include <iostream>
#include <format>
#include <typeinfo>
#include <cstdlib>

import Graphics;

// Funktion zum zufälligen Erstellen von Grafikobjekten
GBase* ClassFactory()
{
GBase *ptr = nullptr;
    switch(std::rand() % 3)
    {
    case 0:
        ptr = new Circle;
break;
    case 1:
        ptr = new Rect;
break;
    case 2:
        ptr = new Polygon;
break;
    }
    return ptr;
}

// main() Funktion
int main()
{
    // Anzahl der zu erstellenden Grafikobjekte
    constexpr auto NOOFOBJECTS = 10;

    // Zeigerfeld für Grafikobjekte anlegen
    GBase *pnObjects[NOOFOBJECTS];

    // Nun 10 zufällige Grafikobjekte erzeugen und ablegen
    for (auto index=0; index<NOOFOBJECTS; index++)
        pnObjects[index] = ClassFactory();

    // Grafikobjekte ausgeben
    for (auto index=0; index<NOOFOBJECTS; index++)
        pnObjects[index]->Draw();

    // Die verschiedenen Grafikobjekte zählen
    auto noOfCircle = 0;
    auto noOfRect = 0;
    auto noOfPolygon = 0;
    for (auto index=0; index<NOOFOBJECTS; index++)
    {
        // Falls Grafikobjekt ein Kreis ist
        if (typeid(*pnObjects[index]) == typeid(Circle))
            noOfCircle++;
        else
            // Falls Grafikobjekt ein Rechteck ist
            if (typeid(*pnObjects[index]) == typeid(Rect))
                noOfRect++;
            else
                // Grafikobjekt ist Polygon
                noOfPolygon++;
    }
    // Anzahl der verschiedenen Grafikobjekte ausgeben
    std::cout << std::format("{} Objekte vom Typ {}\n{} Objekte vom Typ {}\n"
        "{} Objekte vom Typ {}\n", noOfCircle, typeid(Circle).name(),
        noOfRect, typeid(Rect).name(), noOfPolygon, typeid(Polygon).name());
}
