#include <iostream>
#include <format>
#include <string>
#include <map>

using namespace std::string_literals;

// main() Funktion
int main()
{
    // Aktien in map ablegen
    // Schluessel: Hersteller; Datum: Aktienkurs
    std::map<std::string,float> aktien;

    // Map mit Daten füllen
    aktien["VW"s] = 12.f;
    aktien["Ford"s] = 34.45f;
    aktien["BMW"s] = 54.45f;
    aktien["Daimler Chrysler"s] = 123.50f;

    // Ausgabe der Aktienwerte mit 2 Nachkommastellen
    for (auto [hersteller, kurs] : aktien)
        std::cout << std::format("{} Aktie: {:.02f} EUR\n", hersteller, kurs);

    // VW Aktien um 10.00 erhöhen
    std::cout << "-- VW Aktie stiegt um 10.00 EUR --\n";
    aktien["VW"s] += 10.f;

    // Alle Aktien ausgeben
    for (auto [hersteller, kurs]: aktien)
        std::cout << std::format("{} Aktie: {:.02f} EUR\n", hersteller, kurs);

    // Element explizit hinzufügen
    std::cout << "-- Porsche Aktien hinzufuegen --\n";
    aktien.emplace("Porsche"s,560.0f);

    // Daimler Chrysler Aktien in Daimler umbenennen
    // Zuerst kopieren
    std::cout << "-- Daimler Chrysler in Daimler umbenennen --\n";
    aktien["Daimler"s] = aktien["Daimler Chrysler"];
    // und dann löschen!
    aktien.erase("Daimler Chrysler"s);

    // Alle Aktien ausgeben
    for (auto [hersteller, kurs]: aktien)
        std::cout << std::format("{} Aktie: {:.02f} EUR\n", hersteller, kurs);
}
