#include <iostream>
#include <format>

// Funktionsdeklarationen
auto Mittelwert(double wert) -> decltype(wert);

// main() Funktion
int main()
{
    // 10 Zufallszahlen erzeugen
    for (auto index = 0; index < 10; index++)
    {
        // Zufallszahl im Bereich 0..9 erzeugen
        double zahl = rand() % 10;
        // Zufallszahl ausgeben
        std::cout << std::format("Neuer Wert: {}", zahl);
        // Mittelwert berechnen und ausgeben
        std::cout << std::format(" Neuer Mittelwert: {:.2f}\n", Mittelwert(zahl));
    }
}

// Funktion zur Berechnung des Mittelwerts
// Eingabe : Neuer hinzuaddierender Wert
// Ausgabe : Neuer Mittelwert
auto Mittelwert(double wert) ->decltype(wert)
{
    // Summe über alle bisherigen Werte
    static decltype(wert) summe = 0.0;
    // Zähler für Anzahl der Werte
    static auto anzahl = 0;
    // Summe und Anzahl der Werte erhöhen
    summe += wert;
    anzahl++;
    // Mittelwert zurückgeben
    return summe / static_cast<decltype(summe)>(anzahl);
}
