#include <iostream>
#include <format>

// Anzahl der Produkttypen
constexpr auto MAXPRODUCT = 3;

// Funktionsdeklarationen
unsigned long SerialNumber(char prod);

// main() Funktion
int main()
{
    std::cout << "Erzeuge nun Seriennummern:\n";
    // für 15 Produkte Seriennummern erzeugen
    for (auto index = 0; index < 15; index++)
    {
        // Produkttyp zufaellig festlegen
        char prod = (rand() % MAXPRODUCT);
        // Produkttyp und Seriennummer ausgeben
        std::cout << std::format("Produkttyp: {:c}, Seriennummer: {:6}\n",
            prod+'A', SerialNumber(prod));
    }
}

// Funktion zum Erzeugen von Seriennummern
unsigned long SerialNumber(char prod)
{
    // Feld für Seriennummern der einzelnen Produkttypen
    // Das Feld wird mit der Start-Seriennummer des jeweiligen
    // Produkttyps initialisiert
    static decltype(SerialNumber(0)) numbers[MAXPRODUCT]{ 0,100,1000 };
    // Abpruefen ob Produkttyp innerhalb des erlaubten Bereichs
    if ((prod < 0) ||
        (prod > sizeof numbers / sizeof numbers[0]))
        return 0;
    // Seriennummer des Produkttyps erhöhen
    numbers[prod]++;
    // und zurueckgeben
    return numbers[prod];
}
