module;
#include <iostream>
#include <format>
#include <string_view>

export module SerialCom;

// Klassendefinition
export class Com
{
   bool hasCom = false;                  // COM-Objekt besitzt noch keine Schnittstelle
   inline static bool comLocked = false; // statische Verriegelung der Schnittstelle
 public:
   Com() = default; // ctor
   ~Com();          // dtor
   bool WriteCom(std::string_view pszT); // Ausgabe, belegt Schnittstelle
   void ReleaseCom();                     // Schnittstelle freigeben
};
// Definition der Memberfunktionen
// Destruktor
Com::~Com()
{
   // Falls Objekt Schnittstelle besitzt, diese wieder freigeben
   if (hasCom)
      comLocked = false;
}
// Auf Schnittstelle schreiben
bool Com::WriteCom(std::string_view pszT)
{
   bool retVal = true;
   // Wenn Objekt Schnittstelle besitzt, dann schreiben
   if (hasCom)
       std::cout << std::format("{}\n", pszT);
   else
   {
      // Falls Schnittstelle nicht belegt ist
      if (!comLocked)
      {
         // Schnittstelle belegen und Objekt besitzt jetzt Schnittstelle
         comLocked = true;
         hasCom = true;
         // Auf Schnittstelle schreiben
         std::cout << std::format("{}\n", pszT);
      }
      else
      {
         // Anderes Objekt besitzt Schnittstelle
         retVal = false;
      }
   }
   return retVal;
}
// Schnittstelle freigeben
void Com::ReleaseCom()
{
   // Falls Objekt die Schnittstelle besitzt
   if (hasCom)
   {
      // Schnittstelle freigeben
      hasCom = false;
      comLocked = false;
   }
}
