/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import splitFile
*  folgende Datei(en) einzufuegen:
*       string2_02a.cxx
*
*****************************************************************/

#include <iostream>
#include <format>
#include <fstream>
#include <string>

import splitFile;

// Die zu zerlegende Dateiangabe
const char* pFILE = "c:/userdata/temp/data.dat";

// main() Funktion
int main()
{
    std::cout << std::format("Der zu zerlegende Dateiname ist:\n{}\n\n", pFILE);
    // Pfad in Einzelteile zerlegen
    SplitFullPath myPath(pFILE);

    // Laufwerk ausgeben
    auto drive = myPath.GetDrive();
    std::cout << std::format("Laufwerk : {}\n", drive.empty() ? "keines" : drive);

    // Verzeichnis ausgeben
    auto path = myPath.GetPath();
    std::cout << std::format("Verzeichnis: {}\n", path.empty() ? "keines" : path);

    // Dateiname ausgeben
    auto filename = myPath.GetFilename();
    std::cout << std::format("Dateiname : {}\n", filename);

    // akt.Erweiterung gegen .bak austauschen
    // string_view in 
    std::cout << "Tausche Erweiterung gegen \".bak\"\n";
    std::string fname(filename);
    // Suche letzten . im Dateinamen
    // Falls . gefunden
    if (auto extStart = fname.rfind('.'); extStart != std::string::npos)
    {
        // Alles ab . löschen
        fname.erase(extStart);
        // und nun .bak anhängen
        fname.append(".bak");
        std::cout << std::format("Neuer Name : {}\n", fname);
    }
    else
        std::cout << "Keine Erweiterung gefunden!\n";
}
