module;
#include <iostream>
#include <limits>
#include <format>

export module Buttons;

// Basisklassen-Template für 'normalen' Drehschalter
// Default-Datentyp des Button ist int

export template <typename T = unsigned short>

class SpinButton
{
  protected:
    T value;    // akt. Wert
    T minValue;
    T maxValue;
  public:
    SpinButton()
    {
        value = minValue = std::numeric_limits<T>::min();
        maxValue = std::numeric_limits<T>::max();
    }
    void StepUp()
    {
        if (value < maxValue)
           value++;
    }
    void StepDown()
    {
        if (value > minValue)
            value--;
    }
    void ShowProperties()
    {
        std::cout << std::format("Min/Max: ({}/{}), akt. Wert: {}\n",
            minValue, maxValue, value);
    }
};

// Von der Template-Klasse SpinButton abgeleitete Klasse
// ImageSpinButton. Datentyp des Werts von SpinButton ist
// unsigned int. Die in der Basisklasse definierte Eigenschaft
// value dient als Imagelisten-Index.
export class TextSpinButton: public SpinButton<>
{
   const char** textList;
  public:
    TextSpinButton(const char* const il[])
    {
        // Anzahl der Images in der Liste bestimmen
        unsigned short no = 0;
        while (il[no++] != nullptr)
            ;
        // Feld fuer char-Zeiger reservieren
        textList = new const char* [--no];
        // char-Zeiger uebernehmen
        for (unsigned short index = 0; index < no; index++)
        {
            textList[index] = il[index];
        }
        // Min/Max ablegen
        maxValue = --no;
        value = minValue = 0;

    }
    void ShowProperties()
    {
        std::cout << std::format("Min/Max: ({}/{}), akt. Wert: {}\n",
            minValue, maxValue, textList[value]);
    }
};
