#include <iostream>
#include <format>

import Buffer;
import Demo;

int main()
{
    // Ringpuffer fuer 10 int-Daten
    Buffer<int> intBuffer(10);
    // 4 ints im Puffer ablegen
    std::cout << "Lege 4 int-Daten ab:\n";
    for (int index = 0; index < 4; index++)
    {
        if (!intBuffer.Insert(index + 10))
        {
            std::cout << "Pufferueberlauf!!\n";
            break;
        }
        else
            std::cout << index + 10 << ' ';
    }
    // 2 ints wieder auslesen
    std::cout << "\nLese 2 int-Daten aus:\n";
    int idata;
    for (int index=0; index<2; index++)
    {
        if (!intBuffer.Remove(idata))
        {
            std::cout << "Puffer leer!\n";
            break;
        }
        std::cout << idata << ' ';
    }
    // Puffer vollstaendig fuellen
    std::cout << "\nFuelle int-Puffer komplett:\n";
    idata = 100;
    while (intBuffer.Insert(++idata))
        std::cout << idata << ' ';
    // Und wieder vollstaendig auslesen
    std::cout << "\nLeere int-Puffer komplett:\n";
    while (intBuffer.Remove(idata))
        std::cout << idata << ' ';

    // Ringpuffer fuer 5 Demo-Objekte
    Buffer<Demo> demoBuffer(5);
    // Ringpuffer vollstaendig fuellen
    std::cout << "\n\nLege 3 Demo-Objekte ab:\n";
    char demoText[]{ "Demo_A" };
    for (auto index=0; index<3; index++)
    {
        demoBuffer.Insert(Demo(demoText));
        std::cout << demoText << ' ';
        // Position 5 ist der fortlaufende Buchstabe
        demoText[5]++;
    }
    std::cout << "\nLese 1 Demo-Objekt aus:\n";
    Demo resObj;
    demoBuffer.Remove(resObj);
    std::cout << resObj << ' ';
    // Puffer vollstaendig fuellen
    std::cout << "\nFuelle Demo-Puffer komplett:\n";
    demoText[5] = '1';
    while (demoBuffer.Insert(Demo(demoText)))
    {
        std::cout << demoText << ' ';
        demoText[5]++;
    }
    // Und wieder vollstaendig auslesen
    std::cout << "\nLeere Demo-Puffer komplett:\n";
    while (demoBuffer.Remove(resObj))
        std::cout << resObj << ' ';
}
