module;
#include <iostream>

export module Matrix;
// Kurzschreibweise fuer unsigned short
using ushort = unsigned short;

// Klassentemplate Definition
// Feldgroesse wird als non-type Parameter uebergeben
export template <typename T, int ROWS, int COLS=0>
class Matrix
{
    // Feld anlegen
    // Wenn Spaltenzahl (COLS) Null ist, wird
    // Spaltenzahl gleich Zeilenzahl gesetzt
    T matrix[ROWS][COLS==0?ROWS:COLS];
    // Anzahl der Spalten
    const ushort NOOFCOLS = sizeof(matrix)/sizeof(T)/ROWS;
  public:
    // ctor
    Matrix(T val);
    // Ausgabe des Feldinhalts
    void PrintIt() const;
};

// ctor
template <typename T, int ROWS, int COLS>
Matrix<T, ROWS, COLS>::Matrix(T val)
{
    // Feld mit Initialwert belegen
    for (ushort row=0; row<ROWS; row++)
        for (ushort col=0; col<NOOFCOLS; col++)
            matrix[row][col] = val;
}
// Ausgabefunktion
template <typename T, int ROWS, int COLS>
void Matrix<T, ROWS, COLS>::PrintIt() const
{
    for (ushort row=0; row<ROWS; row++)
    {
        for (ushort col=0; col<NOOFCOLS; col++)
            std::cout << matrix[row][col] << ", ";
        std::cout << '\n';
    }
}
