module;
#include <iostream>
#include <string>
#include <string_view>
#include <format>

export module Fahrzeug;

// Basisklasse fuer alle Fahrzeuge
export class Fahrzeug
{
    std::string hersteller;        // Hersteller
    std::string modell;               // Typ
protected:  // Verhindert Definition von Fahrzeug-Objekten
    // ctor
    Fahrzeug(std::string_view man, std::string_view mod) :
        hersteller(man), modell(mod)
    { }
public:
    // dtor
    virtual ~Fahrzeug()
    { }
    // Ausgabe der Daten
    virtual void Print()
    {
        std::cout << std::format("{} {}, ", hersteller, modell);
    }
};

// Klasse fuer Fahrzeuge mit Verbrennungsmotor
export class Benzin: public Fahrzeug
{
    unsigned short tank;        // Tankinhalt
public:
    // ctor
    Benzin(std::string_view man, std::string_view mod, unsigned short ta):
        Fahrzeug(man, mod), tank(ta)
    { }
    // Ausgabe der Daten
    virtual void Print()
    {
        Fahrzeug::Print();
        std::cout << std::format("Tankinhalt: {} Liter\n", tank);
    }
};

// Klasse fuer Elektroauto
export class Elektro: public Fahrzeug
{
    unsigned short batterie;     // Batteriekapzitaet
public:
    // ctor
    Elektro(std::string_view man, std::string_view mod, unsigned short bat):
        Fahrzeug(man, mod), batterie(bat)
    { }
    // Ausgabe der Daten
    virtual void Print()
    {
        Fahrzeug::Print();
        std::cout << std::format("Batteriekap.: {} kW\n", batterie);
    }
};
