#include <iostream>
#include <stdexcept>
#include <typeinfo>

// Globale Konstante für max. Parameterwert des Any ctors
constexpr auto ULIMIT=5;

// Klasse löst im ctor eine out_of_range Exception aus
class Any
{
  public:
    explicit Any(int param)
    {
        if ((param<0) || (param>=ULIMIT))
            throw std::out_of_range("ctor-Parameter <0 oder >=5 !\n");
        std::cout << "ctor Any\n";
    };
    virtual ~Any()
    { std::cout << "dtor Any\n"; };
};

// Klasse löst in Add() eine underflow_error oder overflow_error Exception aus
// wenn Ergebnis der Addition ausserhalb des short Wertebereichs liegt
class Another
{
  public:
    Another()
    { std::cout << "ctor Another\n"; };
    virtual ~Another()
    { std::cout << "dtor Another\n"; };
    short Add(short op1, short op2) const
    {
        short res = op1 + op2;
        if ((op1<0) && (op2<0) && (res>0))
            throw std::underflow_error("Underflow in Another::Compute()\n");
        if ((op1>0) && (op2>0) && (res<0))
            throw std::overflow_error("Overflow in Another::Compute()\n");
        return res;
    }
};

// main() Funktion
int main()
{
    // 5 Any Objekte nacheinander anlegen und wieder löschen
    Any *pAny = nullptr;
    for (auto i=0; i<=ULIMIT; i++)
    {
        pAny = new Any(i);
        // Typ des derefenzierten pAny Zeigers bestimmen
        std::cout << "Type of Any: " << typeid(*pAny).name() << '\n';
        // Any Objekt wieder löschen
        delete pAny;
    }

    // Neues Any Objekt in Another Objekt konvertieren
    pAny = new Any(4);
    Another& ref = dynamic_cast<Another&>(*pAny);
    ref.Add(10,10);
    // Any Objekt wieder löschen
    delete pAny;

    // Another Objekt definieren und verschiedene Additionen durchführen
    Another obj;
    std::cout << "Addition: " << obj.Add(20000,10000) << '\n';
    std::cout << "Addititon " << obj.Add(-20000, 30000) << '\n';
    std::cout << "Addititon " << obj.Add(20000, 30000) << '\n';
}
