#include <iostream>
#include <fmt/format.h>

// Klassentemplate fuer komplexe Zahlen
// Der Real- und Imaginaereanteil muss ein Gleitkomma-Datentyp sein
template <typename T> requires std::floating_point<T>
class Complex
{
    T real;     // Realanteil
    T imag;     // Imaginaeranteil
public:
    // ctor, initialisiert Daten
    Complex(T r, T i) : real(r), imag(i)
    {}
    // Ueberladener Operator << fuer die Datenausgabe
    friend std::ostream& operator << (std::ostream& os, const Complex& obj)
    {
        std::cout << fmt::format("{}+{}i", obj.real, obj.imag);
        return os;
    }
};

// main Funktion
int main()
{
    // Summe zweier int-Variablen ausgeben
    int ival1 = 10, ival2 = 5;
    std::cout << "Summe von " << ival1 << " und " << ival2
        << " ist: " << Sum(ival1, ival2) << '\n';
    // Summe zweier komplexer Zahlen ausgeben
    //Complex comp1{ 1.2,3.4 }, comp2{ 4.2,6.4 };
    //std::cout << "Summe von " << comp1 << " und " << comp2
    //    << " ist: " << Sum(comp1, comp2) << '\n';
}
